import * as i0 from '@angular/core';
import { TemplateRef, Directive, Inject, Input, ContentChild, QueryList, Component, ChangeDetectionStrategy, ContentChildren } from '@angular/core';
import { __decorate, __metadata } from 'tslib';
import { Required } from '@rxap/utilities';
import { GetFromObjectPipe } from '@rxap/pipes';
import { NgIf, NgFor, NgTemplateOutlet } from '@angular/common';

class DataGridCellDefDirective {
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    constructor(template) {
        this.template = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.2", type: DataGridCellDefDirective, isStandalone: true, selector: "[rxapDataGridCellDef]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridCellDef]',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridHeaderCellDefDirective {
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    constructor(template) {
        this.template = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridHeaderCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.2", type: DataGridHeaderCellDefDirective, isStandalone: true, selector: "[rxapDataGridHeaderCellDef]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridHeaderCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridHeaderCellDef]',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridEditCellDefDirective {
    static ngTemplateContextGuard(dir, ctx) {
        return true;
    }
    constructor(template) {
        this.template = template;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridEditCellDefDirective, deps: [{ token: TemplateRef }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.2", type: DataGridEditCellDefDirective, isStandalone: true, selector: "[rxapDataGridEditCellDef]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridEditCellDefDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[rxapDataGridEditCellDef]',
                    standalone: true
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef, decorators: [{
                    type: Inject,
                    args: [TemplateRef]
                }] }]; } });

class DataGridRowDefDirective {
    constructor() {
        this.data = null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridRowDefDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.2", type: DataGridRowDefDirective, isStandalone: true, selector: "[rxapDataGridRowDef]", inputs: { data: "data", name: ["rxapDataGridRowDef", "name"] }, queries: [{ propertyName: "cell", first: true, predicate: DataGridCellDefDirective, descendants: true }, { propertyName: "headerCell", first: true, predicate: DataGridHeaderCellDefDirective, descendants: true }, { propertyName: "editCell", first: true, predicate: DataGridEditCellDefDirective, descendants: true }], ngImport: i0 }); }
}
__decorate([
    Required,
    __metadata("design:type", String)
], DataGridRowDefDirective.prototype, "name", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridRowDefDirective, decorators: [{
            type: Directive,
            args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: '[rxapDataGridRowDef]',
                    standalone: true
                }]
        }], propDecorators: { data: [{
                type: Input
            }], name: [{
                type: Input,
                args: ['rxapDataGridRowDef']
            }], cell: [{
                type: ContentChild,
                args: [DataGridCellDefDirective]
            }], headerCell: [{
                type: ContentChild,
                args: [DataGridHeaderCellDefDirective]
            }], editCell: [{
                type: ContentChild,
                args: [DataGridEditCellDefDirective]
            }] } });

class DataGridReadonlyComponent {
    constructor() {
        this.header = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridReadonlyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.2", type: DataGridReadonlyComponent, isStandalone: true, selector: "rxap-data-grid-readonly", inputs: { header: "header", data: "data" }, host: { classAttribute: "rxap-data-grid-readonly" }, queries: [{ propertyName: "rows", predicate: DataGridRowDefDirective }], ngImport: i0, template: "<table>\n  <thead *ngIf=\"header\">\n  <tr>\n    <th>Label</th>\n    <th>Wert</th>\n  </tr>\n  </thead>\n  <tr *ngFor=\"let row of rows\">\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.headerCell ? row.headerCell.template : defaultHeaderCell;\n          context: { $implicit: row.name }\n        \"\n    ></ng-container>\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.cell ? row.cell.template : defaultCell;\n          context: { $implicit: data | getFromObject: row.name, data: data }\n        \"\n    ></ng-container>\n  </tr>\n</table>\n\n<ng-template #defaultCell let-value>\n  <td>{{ value }}</td>\n</ng-template>\n<ng-template #defaultHeaderCell let-name>\n  <th>{{ name }}</th>\n</ng-template>\n", styles: [""], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: GetFromObjectPipe, name: "getFromObject" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    Required,
    __metadata("design:type", Object)
], DataGridReadonlyComponent.prototype, "data", void 0);
__decorate([
    Required,
    __metadata("design:type", QueryList)
], DataGridReadonlyComponent.prototype, "rows", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.2", ngImport: i0, type: DataGridReadonlyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'rxap-data-grid-readonly', changeDetection: ChangeDetectionStrategy.OnPush, host: { class: 'rxap-data-grid-readonly' }, standalone: true, imports: [NgIf, NgFor, NgTemplateOutlet, GetFromObjectPipe], template: "<table>\n  <thead *ngIf=\"header\">\n  <tr>\n    <th>Label</th>\n    <th>Wert</th>\n  </tr>\n  </thead>\n  <tr *ngFor=\"let row of rows\">\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.headerCell ? row.headerCell.template : defaultHeaderCell;\n          context: { $implicit: row.name }\n        \"\n    ></ng-container>\n    <ng-container\n      *ngTemplateOutlet=\"\n          row.cell ? row.cell.template : defaultCell;\n          context: { $implicit: data | getFromObject: row.name, data: data }\n        \"\n    ></ng-container>\n  </tr>\n</table>\n\n<ng-template #defaultCell let-value>\n  <td>{{ value }}</td>\n</ng-template>\n<ng-template #defaultHeaderCell let-name>\n  <th>{{ name }}</th>\n</ng-template>\n" }]
        }], propDecorators: { header: [{
                type: Input
            }], data: [{
                type: Input
            }], rows: [{
                type: ContentChildren,
                args: [DataGridRowDefDirective]
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { DataGridCellDefDirective, DataGridEditCellDefDirective, DataGridHeaderCellDefDirective, DataGridReadonlyComponent, DataGridRowDefDirective };
//# sourceMappingURL=rxap-data-grid.mjs.map
